## snapd 2.30

=== data/systemd/Makefile ===
#
# Copyright (C) 2017 Canonical Ltd
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

SNAPD_ENVIRONMENT_FILE := /etc/environment
SNAP_MOUNT_DIR := /snap
BINDIR := /usr/bin
LIBEXECDIR := /usr/lib
SYSTEMDSYSTEMUNITDIR := /lib/systemd/system

SYSTEMD_UNITS_GENERATED := $(patsubst %.service.in,%.service,$(wildcard *.service.in))
SYSTEMD_UNITS := ${SYSTEMD_UNITS_GENERATED} $(wildcard *.timer) $(wildcard *.socket)

%.service: %.service.in
	cat $< | \
		sed s:@libexecdir@:${LIBEXECDIR}:g | \
		sed s:@SNAPD_ENVIRONMENT_FILE@:${SNAPD_ENVIRONMENT_FILE}:g | \
		sed s:@bindir@:${BINDIR}:g | \
		sed s:@SNAP_MOUNT_DIR@:${SNAP_MOUNT_DIR}:g  | \
		cat > $@

all: ${SYSTEMD_UNITS}

install: $(SYSTEMD_UNITS)
	# NOTE: old (e.g. 14.04) GNU coreutils doesn't -D with -t
	install -d -m 0755 ${DESTDIR}/${SYSTEMDSYSTEMUNITDIR}
	install -m 0644 -t ${DESTDIR}/${SYSTEMDSYSTEMUNITDIR} $^
	install -m 0755 -t ${DESTDIR}/${LIBEXECDIR}/snapd snapd.core-fixup.sh

clean:
	rm -f ${SYSTEMD_UNITS_GENERATED}

=== tests/main/confinement-classic/test-snapd-hello-classic/Makefile ===
SNAP_NAME = test-snapd-hello-classic
SNAP_VERSION = 0.1

# Ask gcc about the architecture name
arch := $(shell $(CC) -dumpmachine)

ifeq ($(arch),x86_64-linux-gnu)
snap_arch = amd64
dynamic_linker=ld-linux-x86-64.so.2
else ifeq ($(arch),x86_64-suse-linux)
# NOTE: arch needs to be x86_64-linux-gnu, not x86_64-suse-linux
arch := x86_64-linux-gnu
snap_arch = amd64
dynamic_linker=ld-linux-x86-64.so.2
else ifeq ($(arch),i686-linux-gnu)
# NOTE: arch needs to be i386-linux-gnu, not i686-linux-gnu
arch := i386-linux-gnu
snap_arch = i386
dynamic_linker=ld-linux.so.2
else ifeq ($(arch),aarch64-linux-gnu)
snap_arch = arm64
dynamic_linker=ld-linux-aarch64.so.1
else ifeq ($(arch),arm-linux-gnueabihf)
snap_arch = armhf
dynamic_linker=ld-linux-armhf.so.3
else ifeq ($(arch),powerpc64le-linux-gnu)
# NOTE: The architecture name is ppc64el (E-L) but GCC uses powerpc64le (L-E)
snap_arch = ppc64el
dynamic_linker=ld64.so.2
else
$(error cannot translate architecture $(arch) to snap equivalent)
endif

# Name of the snap we're building
snap_file = $(SNAP_NAME)_$(SNAP_VERSION)_$(snap_arch).snap

define snap_yaml
name: $(SNAP_NAME)
version: $(SNAP_VERSION)
summary: A hello-world with classic confinement
architectures: [$(snap_arch)]
apps:
    $(SNAP_NAME):
        command: test-snapd-hello-classic.$(snap_arch).bin
confinement: classic
endef

.PHONY: all
all: $(snap_file)

# Name of the core snap to use
snap_core=core

# Don't search in default locations
LDFLAGS += -Wl,-z,nodefaultlib
LDFLAGS += -Wl,--enable-new-dtags
# Search in the core snap
LDFLAGS += -Wl,-rpath,/snap/$(snap_core)/current/lib/$(arch):/snap/$(snap_core)/current/usr/lib/$(arch)
# Use the dynamic linker from the core snap
LDFLAGS += -Wl,--dynamic-linker=/snap/$(snap_core)/current/lib/$(arch)/$(dynamic_linker)

test-snapd-hello-classic.$(snap_arch).bin: test-snapd-hello-classic.c
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $<

$(snap_file): test-snapd-hello-classic.$(snap_arch).bin meta/snap.yaml
	mksquashfs . $@ -e $@ -noappend -no-xattrs -comp xz

meta: Makefile
	mkdir -p $@

export snap_yaml
meta/snap.yaml: Makefile | meta
	echo "$$snap_yaml" > $@

.ONESHELL:

.PHONY: clean
clean:
	rm -f test-snapd-hello-classic.*.bin
	rm -f meta/snap.yaml
	rm -f *.snap
	rm -f -d meta

=== debian/changelog ===
snapd (2.30-5) unstable; urgency=medium

  * Team upload.
  * add fix-pkg-config-line.patch to fix FTBFS
  * Set XS-Go-Import-Path

 -- Michael Stapelberg <stapelberg@debian.org>  Sat, 10 Feb 2018 23:18:15 +0100

snapd (2.30-4) unstable; urgency=medium

  * Fix Built-Using computation on Debian.
  * Add d/patches/disable-TestDoRequestSerialErrorsOnNoHost.patch to disable
    a flaky test.

 -- Michael Hudson-Doyle <mwhudson@debian.org>  Tue, 16 Jan 2018 13:02:31 +1300

snapd (2.30-3) unstable; urgency=medium

  * Fix arch builds again, sigh,

 -- Michael Hudson-Doyle <mwhudson@debian.org>  Tue, 09 Jan 2018 13:56:48 +1300

snapd (2.30-2) unstable; urgency=medium

  * Fix arch-all-only build. (Closes: 886431)

 -- Michael Hudson-Doyle <mwhudson@debian.org>  Tue, 09 Jan 2018 10:48:20 +1300

snapd (2.30-1) unstable; urgency=medium

  * New upstream release.
  * Remove several patches:
    - 0001-osutil-adjust-StreamCommand-tests-for-golang-1.9.patch: included in
      release.
    - apparmor-compat.patch, no-reexec-on-debian.patch: Removed as upstream
      now implements a better solution to the problem.
    - pb.v1-canonical-path.patch: applied upstream.
  * Stop installing udev/rules.d/80-snappy-assign.rules, gone upstream

 -- Michael Hudson-Doyle <mwhudson@debian.org>  Fri, 05 Jan 2018 09:39:07 +1300

snapd (2.28.5) xenial; urgency=medium

  * New upstream release, LP: #1714984
    - snap-confine: cleanup broken nvidia udev tags
    - cmd/snap-confine: update valid security tag regexp
    - overlord/ifacestate: refresh udev backend on startup
    - dbus: ensure io.snapcraft.Launcher.service is created on re-
      exec
    - snap-confine: add support for handling /dev/nvidia-modeset
    - interfaces/network-control: remove incorrect rules for tun

 -- Michael Vogt <michael.vogt@ubuntu.com>  Fri, 13 Oct 2017 23:25:46 +0200

snapd (2.28.4) xenial; urgency=medium

  * New upstream release, LP: #1714984
    - interfaces/opengl: don't udev tag nvidia devices and use snap-
      confine instead
    - debian: fix replaces/breaks for snap-xdg-open (thanks to apw!)

 -- Michael Vogt <michael.vogt@ubuntu.com>  Wed, 11 Oct 2017 19:40:57 +0200

snapd (2.28.3) xenial; urgency=medium

  * New upstream release, LP: #1714984
    - interfaces/lxd: lxd slot implementation can also be an app
      snap

 -- Michael Vogt <michael.vogt@ubuntu.com>  Wed, 11 Oct 2017 08:20:26 +0200

snapd (2.28.2) xenial; urgency=medium

  * New upstream release, LP: #1714984
    - interfaces: fix udev rules for tun
    - release,cmd,dirs: Redo the distro checks to take into account
      distribution families

 -- Michael Vogt <michael.vogt@ubuntu.com>  Tue, 10 Oct 2017 18:39:58 +0200

snapd (2.28.1) xenial; urgency=medium

  * New upstream release, LP: #1714984
    - snap-confine: update apparmor rules for fedora based basesnaps
    - snapstate: rename refresh hook to post-refresh for consistency

 -- Michael Vogt <michael.vogt@ubuntu.com>  Wed, 27 Sep 2017 17:59:49 -0400

snapd (2.28) xenial; urgency=medium

  * New upstream release, LP: #1714984
    - hooks: rename refresh to after-refresh
    - snap-confine: bind mount /usr/lib/snapd relative to snap-confine
    - cmd,dirs: treat "liri" the same way as "arch"
    - snap-confine: fix base snaps on core
    - hooks: substitute env vars when executing hooks
    - interfaces: updates for default, browser-support, desktop, opengl,
      upower and stub-resolv.conf
    - cmd,dirs: treat manjaro the same as arch
    - systemd: do not run auto-import and repair services on classic
    - packaging/fedora: Ensure vendor/ is empty for builds and fix spec
      to build current master
    - many: fix TestSetConfNumber missing an Unlock and other fragility
      improvements
    - osutil: adjust StreamCommand tests for golang 1.9
    - daemon: allow polkit authorisation to install/remove snaps
    - tests: make TestCmdWatch more robust
    - debian: improve package description
    - interfaces: add netlink kobject uevent to hardware observe
    - debian: update trusted account-keys check on 14.04 packaging
    - interfaces/network-{control,observe}: allow receiving
      kobject_uevent() messages
    - tests: fix lxd test for external backend
    - snap-confine,snap-update-ns: add -no-pie to fix FTBFS on
      go1.7,ppc64
    - corecfg: mock "systemctl" in all corecfg tests
    - tests: fix unit tests on Ubuntu 14.04
    - debian: add missing flags when building static snap-exec
    - many: end-to-end support for the bare base snap
    - overlord/snapstate: SetRootDir from SetUpTest, not in just some
      tests
    - store: have an ad-hoc method on cfg to get its list of uris for
      tests
    - daemon: let client decide whether to allow interactive auth via
      polkit
    - client,daemon,snap,store: add license field
    - overlord/snapstate: rename HasCurrent to IsInstalled, remove
      superfluous/misleading check from All
    - cmd/snap: SetRootDir from SetUpTest, not in just some individual
      tests.
    - systemd: rename snap-repair.{service,timer} to snapd.snap-
      repair.{service,timer}
    - snap-seccomp: remove use of x/net/bpf from tests
    - httputil: more naive per go version way to recreate a default
      transport for tls reconfig
    - cmd/snap-seccomp/main_test.go: add one more syscall for arm64
    - interfaces/opengl: use == to compare, not =
    - cmd/snap-seccomp/main_test.go: add syscalls for armhf and arm64
    - cmd/snap-repair: track and use a lower bound for the time for
      TLS checks
    - interfaces: expose bluez interface on classic OS
    - snap-seccomp: add in-kernel bpf tests
    - overlord: always try to get a serial, lazily on classic
    - tests: add nmcli regression test
    - tests: deal with __PNR_chown on aarch64 to fix FTBFS on arm64
    - tests: add autopilot-introspection interface test
    - vendor: fix artifact from manually editing vendor/vendor.json
    - tests: rename complexion to test-snapd-complexion


=== debian/control ===
Source: snapd
Section: devel
Priority: optional
Maintainer: Steve Langasek <vorlon@debian.org>
Uploaders: Michael Hudson-Doyle <michael.hudson@ubuntu.com>,
	Zygmunt Krynicki <me@zygoon.pl>,
	Luke Faraone <lfaraone@debian.org>
Build-Depends: autoconf,
               automake,
               autotools-dev,
               bash-completion,
               dbus,
               debhelper (>= 9),
               dh-apparmor,
               dh-autoreconf,
               dh-golang (>=1.7),
               dh-systemd,
               fakeroot,
               gettext,
               grub-common,
               gnupg2,
               golang-check.v1-dev,
               golang-context-dev,
               golang-dbus-dev,
               golang-github-coreos-go-systemd-dev,
               golang-github-gorilla-mux-dev,
               golang-github-gosexy-gettext-dev,
               golang-github-mvo5-goconfigparser-dev,
               golang-github-seccomp-libseccomp-golang-dev,
               golang-go,
               golang-go-flags-dev,
               golang-golang-x-crypto-dev,
               golang-golang-x-net-dev,
               golang-gopkg-tomb.v2-dev (>= 0.0~git20161208.0.d5d1b58-1),
               golang-yaml.v2-dev,
               golang-gopkg-macaroon.v1-dev,
               golang-gopkg-mgo.v2-dev,
               golang-gopkg-retry.v1-dev,
               golang-gopkg-tylerb-graceful.v1-dev,
               golang-github-gosexy-gettext-dev,
               golang-any (>=2:1.6) | golang-1.6,
               indent,
               init-system-helpers,
               libcap-dev,
               libapparmor-dev,
               libglib2.0-dev,
               libseccomp-dev,
               libudev-dev,
               openssh-client,
               pkg-config,
               python3,
               python3-docutils,
               python3-markdown,
               squashfs-tools,
               tzdata,
               udev,
               xfslibs-dev
Standards-Version: 3.9.8
Homepage: https://github.com/snapcore/snapd
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/snapd.git
Vcs-Git: git://anonscm.debian.org/collab-maint/snapd.git
XS-Go-Import-Path: github.com/snapcore/snapd

Package: golang-github-ubuntu-core-snappy-dev
Architecture: all
Depends: golang-github-snapcore-snapd-dev, ${misc:Depends}
Section: oldlibs
Description: transitional dummy package
 This is a transitional dummy package. It can safely be removed.

Package: golang-github-snapcore-snapd-dev
Architecture: all
Breaks: golang-github-ubuntu-core-snappy-dev (<< 2.0.6),
        golang-snappy-dev (<< 1.7.3+20160303ubuntu4)
Replaces: golang-github-ubuntu-core-snappy-dev (<< 2.0.6),
          golang-snappy-dev (<< 1.7.3+20160303ubuntu4)
Depends: ${misc:Depends}
Description: snappy development go packages.
 Use these to use the snappy API.

Package: snapd
Architecture: any
Depends: adduser,
         apparmor (>= 2.10.95-0ubuntu2.2),
         ca-certificates,
         gnupg1 | gnupg,
         openssh-client,
         squashfs-tools,
         systemd,
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: snap (<< 2013-11-29-5~), snap-confine (<< 2.23), ubuntu-core-launcher (<< 2.22)
Replaces: snap (<< 2013-11-29-5~), snap-confine (<< 2.23), ubuntu-core-launcher (<< 2.22)
Built-Using: ${Built-Using} ${misc:Built-Using}
Description: Tool to interact with Ubuntu Core Snappy.
 Install, configure, refresh and remove snap packages. Snaps are
 'universal' packages that work across many different Linux systems,
 enabling secure distribution of the latest apps and utilities for
 cloud, servers, desktops and the internet of things.
 .
 This is the CLI for snapd, a background service that takes care of
 snaps on the system. Start with 'snap list' to see installed snaps.

Package: snap-confine
Architecture: any
Section: oldlibs
Depends: snapd (= ${binary:Version}), ${misc:Depends}
Description: Transitional package for snapd
 This is a transitional dummy package. It can safely be removed.

Package: ubuntu-core-launcher
Architecture: any
Depends: snapd (= ${binary:Version}), ${misc:Depends}
Section: oldlibs
Pre-Depends: dpkg (>= 1.15.7.2)
Description: Transitional package for snapd
 This is a transitional dummy package. It can safely be removed.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
#
# These rules should work for any debian-ish distro that uses systemd
# as init.  That does _not_ include Ubuntu 14.04 ("trusty"); look for
# its own special rule file.
#
# Please keep the diff between that and this relatively small, even if
# it means having suboptimal code; these need to be kept in sync by
# sentient bags of meat.

#export DH_VERBOSE=1
export DH_OPTIONS
export DH_GOPKG := github.com/snapcore/snapd
#export DEB_BUILD_OPTIONS=nocheck
export DH_GOLANG_EXCLUDES=tests
export DH_GOLANG_GO_GENERATE=1

export PATH:=${PATH}:${CURDIR}
# make sure that correct go version is found on trusty
export PATH:=/usr/lib/go-1.6/bin:${PATH}

include /etc/os-release

# this is overridden in the ubuntu/14.04 release branch
SYSTEMD_UNITS_DESTDIR="lib/systemd/system/"

# The go tool does not fully support vendoring with gccgo, but we can
# work around that by constructing the appropriate -I flag by hand.
GCCGO := $(shell go tool dist env > /dev/null 2>&1 && echo no || echo yes)

# Disable -buildmode=pie mode on i386 as can panics in spectacular
# ways (LP: #1711052).
# See also https://forum.snapcraft.io/t/artful-i386-panics/
# Note while the panic is only on artful, that's because artful
# detects it; the issue potentially there on older things.
BUILDFLAGS:=-pkgdir=$(CURDIR)/_build/std
ifneq ($(shell dpkg-architecture -qDEB_HOST_ARCH),i386)
BUILDFLAGS+= -buildmode=pie
endif

GCCGOFLAGS=
ifeq ($(GCCGO),yes)
GOARCH := $(shell go env GOARCH)
GOOS := $(shell go env GOOS)
BUILDFLAGS:=
GCCGOFLAGS=-gccgoflags="-I $(CURDIR)/_build/pkg/gccgo_$(GOOS)_$(GOARCH)/$(DH_GOPKG)/vendor"
export DH_GOLANG_GO_GENERATE=0
endif

# check if we need to include the testkeys in the binary
TAGS=
ifneq (,$(filter testkeys,$(DEB_BUILD_OPTIONS)))
	TAGS=-tags withtestkeys
endif

BUILT_USING_PACKAGES=
# export DEB_BUILD_MAINT_OPTIONS = hardening=+all
# DPKG_EXPORT_BUILDFLAGS = 1
# include /usr/share/dpkg/buildflags.mk

# Currently, we enable confinement for Ubuntu only, not for derivatives,
# because derivatives may have different kernels that don't support all the
# required confinement features and we don't to mislead anyone about the
# security of the system.  Discuss a proper approach to this for downstreams
# if and when they approach us.
ifeq ($(shell dpkg-vendor --query Vendor),Ubuntu)
    # On Ubuntu 16.04 we need to produce a build that can be used on wide
    # variety of systems. As such we prefer static linking over dynamic linking
    # for stability, predicability and easy of deployment. We need to link some
    # things dynamically though: udev has no stable IPC protocol between
    # libudev and udevd so we need to link with it dynamically.
    VENDOR_ARGS=--enable-nvidia-multiarch --enable-static-libcap --enable-static-libapparmor --enable-static-libseccomp
    BUILT_USING_PACKAGES=libcap-dev libapparmor-dev libseccomp-dev
    BUILT_USING=$(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W $(BUILT_USING_PACKAGES))
else
ifeq ($(shell dpkg-vendor --query Vendor),Debian)
    VENDOR_ARGS=--enable-nvidia-multiarch
    BUILT_USING=
else
    VENDOR_ARGS=--disable-apparmor
endif
endif

%:
	dh $@ --buildsystem=golang --with=golang --fail-missing --with systemd --builddirectory=_build

override_dh_fixperms:
	dh_fixperms -Xusr/lib/snapd/snap-confine


# The .real profile is a workaround for a bug in dpkg LP: #1673247 that causes
# ubiquity to crash. It allows us to "move" the snap-confine profile from
# snap-confine into snapd in a way that works with old dpkg that is in the live
# CD image.
#
# Because both the usual and the .real profile describe the same binary the
# .real profile takes priority (as it is loaded later).
override_dh_installdeb:
	dh_apparmor --profile-name=usr.lib.snapd.snap-confine.real -psnapd
	dh_installdeb

override_dh_clean:
ifneq (,$(TEST_GITHUB_AUTOPKGTEST))
	# this will be set by the GITHUB webhook to trigger a autopkgtest
	# we only need to run "govendor sync" here and then its ready
	(export GOPATH="/tmp/go"; \
	  mkdir -p /tmp/go/src/github.com/snapcore/; \
          cp -ar . /tmp/go/src/github.com/snapcore/snapd; \
	  go get -u github.com/kardianos/govendor; \
	  (cd /tmp/go/src/github.com/snapcore/snapd ; /tmp/go/bin/govendor sync); \
	  cp -ar /tmp/go/src/github.com/snapcore/snapd/vendor/ .; \
        )
endif
	dh_clean
	$(MAKE) -C data clean
	# XXX: hacky
	$(MAKE) -C cmd distclean || true

override_dh_auto_build:
	# usually done via `go generate` but that is not supported on powerpc
	./mkversion.sh
	# Build golang bits
	mkdir -p _build/src/$(DH_GOPKG)/cmd/snap/test-data
	cp -a cmd/snap/test-data/*.gpg _build/src/$(DH_GOPKG)/cmd/snap/test-data/
	dh_auto_build -- $(BUILDFLAGS) $(TAGS) $(GCCGOFLAGS)

	# (static linking on powerpc with cgo is broken)
ifneq ($(shell dpkg-architecture -qDEB_HOST_ARCH),powerpc)
	# Generate static snap-exec and snap-update-ns - it somehow includes CGO so
	# we must force a static build here. We need a static snap-{exec,update-ns}
	# inside the core snap because not all bases will have a libc
	(cd _build/bin && GOPATH=$$(pwd)/.. CGO_ENABLED=0 go build $(GCCGOFLAGS) $(DH_GOPKG)/cmd/snap-exec)
	(cd _build/bin && GOPATH=$$(pwd)/.. go build --ldflags '-extldflags "-static"' $(GCCGOFLAGS) $(DH_GOPKG)/cmd/snap-update-ns)

	# ensure we generated a static build
	$(shell	if ldd _build/bin/snap-exec; then false "need static build"; fi)
	$(shell	if ldd _build/bin/snap-update-ns; then false "need static build"; fi)
endif

	# Build C bits, sadly manually
	cd cmd && ( autoreconf -i -f )
	cd cmd && ( ./configure --prefix=/usr --libexecdir=/usr/lib/snapd $(VENDOR_ARGS))
	$(MAKE) -C cmd all

	# Generate the real systemd/dbus/env config files
	$(MAKE) -C data all

override_dh_auto_test:
	dh_auto_test -- $(GCCGOFLAGS)
# a tested default (production) build should have no test keys
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# check that only the main trusted account-keys are included
	[ $$(strings _build/bin/snapd|grep -c -E "public-key-sha3-384: [a-zA-Z0-9_-]{64}") -eq 2 ]
	strings _build/bin/snapd|grep -c "^public-key-sha3-384: -CvQKAwRQ5h3Ffn10FILJoEZUXOv6km9FwA80-Rcj-f-6jadQ89VRswHNiEB9Lxk$$"
	strings _build/bin/snapd|grep -c "^public-key-sha3-384: d-JcZF9nD9eBw7bwMnH61x-bklnQOhQud1Is6o_cn2wTj8EYDi9musrIT9z2MdAa$$"
	# same for snap-repair
	[ $$(strings _build/bin/snap-repair|grep -c -E "public-key-sha3-384: [a-zA-Z0-9_-]{64}") -eq 3 ]
	# common with snapd
	strings _build/bin/snap-repair|grep -c "^public-key-sha3-384: -CvQKAwRQ5h3Ffn10FILJoEZUXOv6km9FwA80-Rcj-f-6jadQ89VRswHNiEB9Lxk$$"
	strings _build/bin/snap-repair|grep -c "^public-key-sha3-384: d-JcZF9nD9eBw7bwMnH61x-bklnQOhQud1Is6o_cn2wTj8EYDi9musrIT9z2MdAa$$"
	# repair-root
	strings _build/bin/snap-repair|grep -c "^public-key-sha3-384: nttW6NfBXI_E-00u38W-KH6eiksfQNXuI7IiumoV49_zkbhM0sYTzSnFlwZC-W4t$$"
endif
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# run the snap-confine tests
	$(MAKE) -C cmd check
endif

override_dh_install-indep:
	# we do not need this in the package, its just needed during build
	rm -rf ${CURDIR}/debian/tmp/usr/bin/xgettext-go
	# toolbelt is not shippable
	rm -f ${CURDIR}/debian/tmp/usr/bin/toolbelt
	# we do not like /usr/bin/snappy anymore
	rm -f ${CURDIR}/debian/tmp/usr/bin/snappy
	dh_install

override_dh_install-arch:
	# we do not need this in the package, its just needed during build
	rm -rf ${CURDIR}/debian/tmp/usr/bin/xgettext-go
	# toolbelt is not shippable
	rm -f ${CURDIR}/debian/tmp/usr/bin/toolbelt
	# we do not like /usr/bin/snappy anymore
	rm -f ${CURDIR}/debian/tmp/usr/bin/snappy
	# i18n stuff
	mkdir -p debian/snapd/usr/share
	if [ -d share/locale ]; then \
		cp -R share/locale debian/snapd/usr/share; \
	fi

	# install snapd's systemd units / upstart jobs, done
	# here instead of debian/snapd.install because the
	# ubuntu/14.04 release branch adds/changes bits here
	$(MAKE) -C data install DESTDIR=$(CURDIR)/debian/snapd/ \
		SYSTEMDSYSTEMUNITDIR=$(SYSTEMD_UNITS_DESTDIR)

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/snapd-\$1\.tar\.gz/,\
uversionmangle=s/(\d)[_\.\-\+]?(RC|rc|pre|dev|beta|alpha)[.]?(\d*)$/\$1~\$2\$3/ \
  https://github.com/snapcore/snapd/tags .*/v?(\d\S*)\.tar\.gz

## snapd 2.31.1~14.04

=== data/systemd/Makefile ===
#
# Copyright (C) 2017 Canonical Ltd
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

SNAPD_ENVIRONMENT_FILE := /etc/environment
SNAP_MOUNT_DIR ?= /snap
BINDIR := /usr/bin
LIBEXECDIR := /usr/lib
SYSTEMDSYSTEMUNITDIR := /lib/systemd/system

SYSTEMD_UNITS_GENERATED := $(wildcard *.in)
SYSTEMD_UNITS = $(SYSTEMD_UNITS_GENERATED:.in=) $(wildcard *.timer) $(wildcard *.socket)

# The special mount unit for "/snap" must be named after the path and the path
# is a variable.  Compute it in make for simplicity. This is equivalent to
# calling systemd-escape --path $(SNAP_MOUNT_DIR)
snap_mount_unit=$(subst /,-,$(patsubst %/,%,$(patsubst /%,%,$(SNAP_MOUNT_DIR)))).mount

# Yes, we want the extra unit too, thank you
SYSTEMD_UNITS += $(snap_mount_unit)

.PHONY: all
all: $(SYSTEMD_UNITS)

.PHONY: install
install: $(filter-out snap.mount,$(SYSTEMD_UNITS)) $(snap_mount_unit)
	# NOTE: old (e.g. 14.04) GNU coreutils doesn't -D with -t
	install -d -m 0755 $(DESTDIR)/$(SYSTEMDSYSTEMUNITDIR)
	install -m 0644 -t $(DESTDIR)/$(SYSTEMDSYSTEMUNITDIR) $^
	install -d -m 0755 $(DESTDIR)/$(LIBEXECDIR)/snapd
	install -m 0755 -t $(DESTDIR)/$(LIBEXECDIR)/snapd snapd.core-fixup.sh

.PHONY: clean
clean:
	rm -f $(SYSTEMD_UNITS_GENERATED:.in=) $(snap_mount_unit)

%: %.in
	cat $< | \
		sed s:@libexecdir@:$(LIBEXECDIR):g | \
		sed s:@SNAPD_ENVIRONMENT_FILE@:$(SNAPD_ENVIRONMENT_FILE):g | \
		sed s:@bindir@:$(BINDIR):g | \
		sed s:@SNAP_MOUNT_DIR@:$(SNAP_MOUNT_DIR):g  | \
		cat > $@

# If SNAP_MOUNT_DIR uses non-default location then rename snap.mount
# so that the directory name is encoded in the file name.
ifneq ($(snap_mount_unit),snap.mount)
$(snap_mount_unit): snap.mount
	cp $< $@
endif

## snapd 2.31.2~14.04

=== data/Makefile ===
all install clean:
	$(MAKE) -C systemd $@
	$(MAKE) -C dbus $@
	$(MAKE) -C env $@

## snapd 2.32.5+18.04

=== data/Makefile ===
all install clean:
	$(MAKE) -C systemd $@
	$(MAKE) -C dbus $@
	$(MAKE) -C env $@
	$(MAKE) -C desktop $@

=== data/desktop/Makefile ===
#
# Copyright (C) 2018 Canonical Ltd
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

BINDIR = /usr/bin
SYSCONFXDGAUTOSTARTDIR = /etc/xdg/autostart

SOURCES = snap-userd-autostart.desktop.in
DESKTOP_FILES = $(SOURCES:.in=)

.PHONY: all
all: $(DESKTOP_FILES)

.PHONY: install
install: $(DESKTOP_FILES)
	# NOTE: old (e.g. 14.04) GNU coreutils doesn't -D with -t
	install -d -m 0755 $(DESTDIR)/$(SYSCONFXDGAUTOSTARTDIR)
	install -m 0644 -t $(DESTDIR)/$(SYSCONFXDGAUTOSTARTDIR) $^

.PHONY: clean
clean:
	rm -f $(DESKTOP_FILES)

%: %.in
	cat $< | \
		sed s:@bindir@:$(BINDIR):g | \
		cat > $@

=== data/systemd/Makefile ===
--- 
+++ 
@@ -22,19 +22,11 @@
 SYSTEMD_UNITS_GENERATED := $(wildcard *.in)
 SYSTEMD_UNITS = $(SYSTEMD_UNITS_GENERATED:.in=) $(wildcard *.timer) $(wildcard *.socket)
 
-# The special mount unit for "/snap" must be named after the path and the path
-# is a variable.  Compute it in make for simplicity. This is equivalent to
-# calling systemd-escape --path $(SNAP_MOUNT_DIR)
-snap_mount_unit=$(subst /,-,$(patsubst %/,%,$(patsubst /%,%,$(SNAP_MOUNT_DIR)))).mount
-
-# Yes, we want the extra unit too, thank you
-SYSTEMD_UNITS += $(snap_mount_unit)
-
 .PHONY: all
 all: $(SYSTEMD_UNITS)
 
 .PHONY: install
-install: $(filter-out snap.mount,$(SYSTEMD_UNITS)) $(snap_mount_unit)
+install: $(SYSTEMD_UNITS)
 	# NOTE: old (e.g. 14.04) GNU coreutils doesn't -D with -t
 	install -d -m 0755 $(DESTDIR)/$(SYSTEMDSYSTEMUNITDIR)
 	install -m 0644 -t $(DESTDIR)/$(SYSTEMDSYSTEMUNITDIR) $^
@@ -43,7 +35,7 @@
 
 .PHONY: clean
 clean:
-	rm -f $(SYSTEMD_UNITS_GENERATED:.in=) $(snap_mount_unit)
+	rm -f $(SYSTEMD_UNITS_GENERATED:.in=)
 
 %: %.in
 	cat $< | \
@@ -52,10 +44,3 @@
 		sed s:@bindir@:$(BINDIR):g | \
 		sed s:@SNAP_MOUNT_DIR@:$(SNAP_MOUNT_DIR):g  | \
 		cat > $@
-
-# If SNAP_MOUNT_DIR uses non-default location then rename snap.mount
-# so that the directory name is encoded in the file name.
-ifneq ($(snap_mount_unit),snap.mount)
-$(snap_mount_unit): snap.mount
-	cp $< $@
-endif

## snapd 2.37

=== debian/changelog ===
snapd (2.37-3) unstable; urgency=medium

  * Fix --no-arch-any build.

 -- Michael Hudson-Doyle <mwhudson@debian.org>  Thu, 24 Jan 2019 16:11:17 +1300

snapd (2.37-2) unstable; urgency=medium

  * d/patches/0010-man-page-sections.patch: fix a couple of instances of the
    lintian warning 'manpage-section-mismatch'.

 -- Michael Hudson-Doyle <mwhudson@debian.org>  Thu, 24 Jan 2019 09:52:09 +1300

snapd (2.37-1) unstable; urgency=medium

  [ Michael Hudson-Doyle ]
  * New upstream version.
  * d/control: make myself Maintainer, use my Debian address, update Vcs-* to
    point to salsa.
  * Add new build-dependencies.
  * d/watch: update to download new upstream-provided no-vendor tarballs.
  * d/patches: refresh/drop.
  * d/patches/no-snapfuse.patch: do not depend on snapfuse fork of squashfuse.
  * d/patches/upstram-bolt.patch: use upstream version of boltdb.
  * d/patches/systemd-activation-compat.patch: compatibility for the
    newer go-systemd in debian

  [ Ondřej Nový ]
  * d/copyright: Use https protocol in Format field
  * d/changelog: Remove trailing whitespaces

  [ Zygmunt Krynicki ]
  * Update unreleased package to 2.37
  * Drop and recreate all patches
  * Add patches for failing unit tests
  * Reconcile packaging with snapd upstream

 -- Zygmunt Krynicki <me@zygoon.pl>  Tue, 22 Jan 2019 12:39:58 +0100

## snapd 2.37.2

=== debian/changelog ===
snapd (2.37.2-1) unstable; urgency=medium

  * New upstream releease. 

 -- Michael Hudson-Doyle <mwhudson@debian.org>  Thu, 07 Feb 2019 21:26:34 +1300

snapd (2.37.1-1) unstable; urgency=medium

  * New upstream release.
  * d/patches/0009-interfaces-apparmor-mock-presence-of-overlayfs-root.patch:
    applied upstream

 -- Zygmunt Krynicki <me@zygoon.pl>  Tue, 29 Jan 2019 19:24:35 +0100

## snapd 2.37.4

=== data/dbus/Makefile ===
#
# Copyright (C) 2017 Canonical Ltd
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

BINDIR := /usr/bin
DBUSSERVICESDIR := /usr/share/dbus-1/services

SERVICES_GENERATED := $(patsubst %.service.in,%.service,$(wildcard *.service.in))
SERVICES := ${SERVICES_GENERATED}

%.service: %.service.in
	cat $< | sed 's:@bindir@:${BINDIR}:g' | cat > $@

all: ${SERVICES}

install: ${SERVICES}
	# NOTE: old (e.g. 14.04) GNU coreutils doesn't -D with -t
	install -d -m 0755 ${DESTDIR}/${DBUSSERVICESDIR}
	install -m 0644 -t ${DESTDIR}/${DBUSSERVICESDIR} $^

clean:
	rm -f ${SERVICES_GENERATED}

=== debian/changelog ===
snapd (2.37.4-1) unstable; urgency=medium

  * New upstream release
  * d/patches0008-snap-squashsh-skip-TestBuildDate-on-Debian.patch: drop,
    fixed upstream

 -- Zygmunt Krynicki <me@zygoon.pl>  Thu, 28 Feb 2019 18:21:26 +0100

snapd (2.37.3-1) unstable; urgency=medium

  * New upstream release

 -- Zygmunt Krynicki <me@zygoon.pl>  Tue, 19 Feb 2019 13:46:24 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Source: snapd
 Section: devel
 Priority: optional
-Maintainer: Steve Langasek <vorlon@debian.org>
-Uploaders: Michael Hudson-Doyle <michael.hudson@ubuntu.com>,
+Maintainer: Michael Hudson-Doyle <mwhudson@debian.org>
+Uploaders: Steve Langasek <vorlon@debian.org>,
 	Zygmunt Krynicki <me@zygoon.pl>,
 	Luke Faraone <lfaraone@debian.org>
 Build-Depends: autoconf,
@@ -10,11 +10,10 @@
                autotools-dev,
                bash-completion,
                dbus,
-               debhelper (>= 9),
+               debhelper (>= 9.20160709),
                dh-apparmor,
                dh-autoreconf,
                dh-golang (>=1.7),
-               dh-systemd,
                fakeroot,
                gettext,
                grub-common,
@@ -22,16 +21,20 @@
                golang-check.v1-dev,
                golang-context-dev,
                golang-dbus-dev,
+               golang-github-boltdb-bolt-dev,
                golang-github-coreos-go-systemd-dev,
+               golang-github-juju-ratelimit-dev,
                golang-github-gorilla-mux-dev,
                golang-github-gosexy-gettext-dev,
+               golang-github-kr-pretty-dev,
+               golang-github-kr-text-dev,
                golang-github-mvo5-goconfigparser-dev,
                golang-github-seccomp-libseccomp-golang-dev,
                golang-go,
                golang-go-flags-dev,
                golang-golang-x-crypto-dev,
                golang-golang-x-net-dev,
-               golang-gopkg-tomb.v2-dev (>= 0.0~git20161208.0.d5d1b58-1),
+               golang-gopkg-tomb.v2-dev (>= 0.0~git20161208.0.d5d1b58),
                golang-yaml.v2-dev,
                golang-gopkg-macaroon.v1-dev,
                golang-gopkg-mgo.v2-dev,
@@ -40,7 +43,6 @@
                golang-github-gosexy-gettext-dev,
                golang-any (>=2:1.6) | golang-1.6,
                indent,
-               init-system-helpers,
                libcap-dev,
                libapparmor-dev,
                libglib2.0-dev,
@@ -57,8 +59,8 @@
                xfslibs-dev
 Standards-Version: 3.9.8
 Homepage: https://github.com/snapcore/snapd
-Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/snapd.git
-Vcs-Git: git://anonscm.debian.org/collab-maint/snapd.git
+Vcs-Browser: https://salsa.debian.org/debian/snapd
+Vcs-Git: https://salsa.debian.org/debian/snapd.git
 XS-Go-Import-Path: github.com/snapcore/snapd
 
 Package: golang-github-ubuntu-core-snappy-dev
@@ -87,19 +89,22 @@
          openssh-client,
          squashfs-tools,
          systemd,
+         udev,
          ${misc:Depends},
          ${shlibs:Depends}
-Breaks: snap (<< 2013-11-29-5~), snap-confine (<< 2.23), ubuntu-core-launcher (<< 2.22)
-Replaces: snap (<< 2013-11-29-5~), snap-confine (<< 2.23), ubuntu-core-launcher (<< 2.22)
+Replaces: ubuntu-snappy (<< 1.9), ubuntu-snappy-cli (<< 1.9), snap-confine (<< 2.23), ubuntu-core-launcher (<< 2.22), snapd-xdg-open (<= 0.0.0)
+Breaks: ubuntu-snappy (<< 1.9), ubuntu-snappy-cli (<< 1.9), snap-confine (<< 2.23), ubuntu-core-launcher (<< 2.22), snapd-xdg-open (<= 0.0.0), ${snapd:Breaks}
+Recommends: gnupg
+Suggests: zenity | kdialog
+Conflicts: snap (<< 2013-11-29-1ubuntu1)
 Built-Using: ${Built-Using} ${misc:Built-Using}
-Description: Tool to interact with Ubuntu Core Snappy.
+Description: Daemon and tooling that enable snap packages
  Install, configure, refresh and remove snap packages. Snaps are
  'universal' packages that work across many different Linux systems,
  enabling secure distribution of the latest apps and utilities for
  cloud, servers, desktops and the internet of things.
  .
- This is the CLI for snapd, a background service that takes care of
- snaps on the system. Start with 'snap list' to see installed snaps.
+ Start with 'snap list' to see installed snaps.
 
 Package: snap-confine
 Architecture: any
@@ -115,3 +120,4 @@
 Pre-Depends: dpkg (>= 1.15.7.2)
 Description: Transitional package for snapd
  This is a transitional dummy package. It can safely be removed.
+

=== debian/rules ===
--- 
+++ 
@@ -21,6 +21,17 @@
 export PATH:=/usr/lib/go-1.6/bin:${PATH}
 
 include /etc/os-release
+
+# On 18.04 the released version of apt (1.6.1) has a bug that causes
+# problem on "apt purge snapd". To ensure this won't happen add the
+# right dependency on 18.04.
+ifeq (${VERSION_ID},"18.04")
+	SUBSTVARS = -Vsnapd:Breaks="apt (<< 1.6.3)"
+endif
+# Same as above for 18.10 just a different version.
+ifeq (${VERSION_ID},"18.10")
+	SUBSTVARS = -Vsnapd:Breaks="apt (<< 1.7.0~alpha2)"
+endif
 
 # this is overridden in the ubuntu/14.04 release branch
 SYSTEMD_UNITS_DESTDIR="lib/systemd/system/"
@@ -46,6 +57,8 @@
 BUILDFLAGS:=
 GCCGOFLAGS=-gccgoflags="-I $(CURDIR)/_build/pkg/gccgo_$(GOOS)_$(GOARCH)/$(DH_GOPKG)/vendor"
 export DH_GOLANG_GO_GENERATE=0
+# workaround for https://github.com/golang/go/issues/23721
+export GOMAXPROCS=2
 endif
 
 # check if we need to include the testkeys in the binary
@@ -53,6 +66,8 @@
 ifneq (,$(filter testkeys,$(DEB_BUILD_OPTIONS)))
 	TAGS=-tags withtestkeys
 endif
+
+DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 
 BUILT_USING_PACKAGES=
 # export DEB_BUILD_MAINT_OPTIONS = hardening=+all
@@ -70,17 +85,20 @@
     # for stability, predicability and easy of deployment. We need to link some
     # things dynamically though: udev has no stable IPC protocol between
     # libudev and udevd so we need to link with it dynamically.
-    VENDOR_ARGS=--enable-nvidia-multiarch --enable-static-libcap --enable-static-libapparmor --enable-static-libseccomp
+    VENDOR_ARGS=--enable-nvidia-multiarch --enable-static-libcap --enable-static-libapparmor --enable-static-libseccomp --with-host-arch-triplet=$(DEB_HOST_MULTIARCH)
+ifeq ($(shell dpkg-architecture -qDEB_HOST_ARCH),amd64)
+		VENDOR_ARGS+= --with-host-arch-32bit-triplet=$(shell dpkg-architecture -f -ai386 -qDEB_HOST_MULTIARCH)
+endif
     BUILT_USING_PACKAGES=libcap-dev libapparmor-dev libseccomp-dev
-    BUILT_USING=$(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W $(BUILT_USING_PACKAGES))
 else
 ifeq ($(shell dpkg-vendor --query Vendor),Debian)
     VENDOR_ARGS=--enable-nvidia-multiarch
-    BUILT_USING=
+    BUILT_USING_PACKAGES=libcap-dev
 else
     VENDOR_ARGS=--disable-apparmor
 endif
 endif
+BUILT_USING=$(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W $(BUILT_USING_PACKAGES))
 
 %:
 	dh $@ --buildsystem=golang --with=golang --fail-missing --with systemd --builddirectory=_build
@@ -138,6 +156,20 @@
 	$(shell	if ldd _build/bin/snap-update-ns; then false "need static build"; fi)
 endif
 
+	# ensure snap-seccomp is build with a static libseccomp on Ubuntu
+ifeq ($(shell dpkg-vendor --query Vendor),Ubuntu)
+	# (static linking on powerpc with cgo is broken)
+ ifneq ($(shell dpkg-architecture -qDEB_HOST_ARCH),powerpc)
+	sed -i "s|#cgo LDFLAGS:|#cgo LDFLAGS: /usr/lib/$(shell dpkg-architecture -qDEB_TARGET_MULTIARCH)/libseccomp.a|" _build/src/$(DH_GOPKG)/cmd/snap-seccomp/main.go
+	(cd _build/bin && GOPATH=$$(pwd)/.. CGO_LDFLAGS_ALLOW="/.*/libseccomp.a" go build $(GCCGOFLAGS) $(DH_GOPKG)/cmd/snap-seccomp)
+	# ensure that libseccomp is not dynamically linked
+	ldd _build/bin/snap-seccomp
+	test "$$(ldd _build/bin/snap-seccomp | grep libseccomp)" = ""
+	# revert again so that the subsequent tests work
+	sed -i "s|#cgo LDFLAGS: /usr/lib/$(shell dpkg-architecture -qDEB_TARGET_MULTIARCH)/libseccomp.a|#cgo LDFLAGS:|" _build/src/$(DH_GOPKG)/cmd/snap-seccomp/main.go
+ endif
+endif
+
 	# Build C bits, sadly manually
 	cd cmd && ( autoreconf -i -f )
 	cd cmd && ( ./configure --prefix=/usr --libexecdir=/usr/lib/snapd $(VENDOR_ARGS))
@@ -155,42 +187,3 @@
 	strings _build/bin/snapd|grep -c "^public-key-sha3-384: -CvQKAwRQ5h3Ffn10FILJoEZUXOv6km9FwA80-Rcj-f-6jadQ89VRswHNiEB9Lxk$$"
 	strings _build/bin/snapd|grep -c "^public-key-sha3-384: d-JcZF9nD9eBw7bwMnH61x-bklnQOhQud1Is6o_cn2wTj8EYDi9musrIT9z2MdAa$$"
 	# same for snap-repair
-	[ $$(strings _build/bin/snap-repair|grep -c -E "public-key-sha3-384: [a-zA-Z0-9_-]{64}") -eq 3 ]
-	# common with snapd
-	strings _build/bin/snap-repair|grep -c "^public-key-sha3-384: -CvQKAwRQ5h3Ffn10FILJoEZUXOv6km9FwA80-Rcj-f-6jadQ89VRswHNiEB9Lxk$$"
-	strings _build/bin/snap-repair|grep -c "^public-key-sha3-384: d-JcZF9nD9eBw7bwMnH61x-bklnQOhQud1Is6o_cn2wTj8EYDi9musrIT9z2MdAa$$"
-	# repair-root
-	strings _build/bin/snap-repair|grep -c "^public-key-sha3-384: nttW6NfBXI_E-00u38W-KH6eiksfQNXuI7IiumoV49_zkbhM0sYTzSnFlwZC-W4t$$"
-endif
-ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
-	# run the snap-confine tests
-	$(MAKE) -C cmd check
-endif
-
-override_dh_install-indep:
-	# we do not need this in the package, its just needed during build
-	rm -rf ${CURDIR}/debian/tmp/usr/bin/xgettext-go
-	# toolbelt is not shippable
-	rm -f ${CURDIR}/debian/tmp/usr/bin/toolbelt
-	# we do not like /usr/bin/snappy anymore
-	rm -f ${CURDIR}/debian/tmp/usr/bin/snappy
-	dh_install
-
-override_dh_install-arch:
-	# we do not need this in the package, its just needed during build
-	rm -rf ${CURDIR}/debian/tmp/usr/bin/xgettext-go
-	# toolbelt is not shippable
-	rm -f ${CURDIR}/debian/tmp/usr/bin/toolbelt
-	# we do not like /usr/bin/snappy anymore
-	rm -f ${CURDIR}/debian/tmp/usr/bin/snappy
-	# i18n stuff
-	mkdir -p debian/snapd/usr/share
-	if [ -d share/locale ]; then \
-		cp -R share/locale debian/snapd/usr/share; \
-	fi
-
-	# install snapd's systemd units / upstart jobs, done
-	# here instead of debian/snapd.install because the
-	# ubuntu/14.04 release branch adds/changes bits here
-	$(MAKE) -C data install DESTDIR=$(CURDIR)/debian/snapd/ \
-		SYSTEMDSYSTEMUNITDIR=$(SYSTEMD_UNITS_DESTDIR)

=== debian/tests/control ===
Tests: integrationtests
Restrictions: allow-stderr, rw-build-tree, needs-root, breaks-testbed, isolation-machine
Depends: @builddeps@,
         bzr,
         ca-certificates,
         git,
         golang-golang-x-net-dev,
         locales,
         openssh-server,
         netcat-openbsd,
         net-tools,
         snapd

## snapd 2.38~14.04

=== data/Makefile ===
all install clean:
	$(MAKE) -C systemd $@
	$(MAKE) -C systemd-env $@
	$(MAKE) -C dbus $@
	$(MAKE) -C env $@
	$(MAKE) -C desktop $@

## snapd 2.42.1

=== debian/changelog ===
snapd (2.42.1-1+rpi1) bullseye-staging; urgency=medium

  [changes brought forward from 2.27.2-2+rpi1 by Peter Michael Green <plugwash@raspbian.org> at Thu, 24 Aug 2017 17:53:18 +0000]
  * Treat unknown derivatives the same as Debian.
  * Disable testsuite.
  * Fix clean target.

 -- Raspbian forward porter <root@raspbian.org>  Sat, 16 Nov 2019 08:46:37 +0000

snapd (2.42.1-1) unstable; urgency=medium

  * New upstream release, LP: #1846181
    - interfaces: de-duplicate emitted update-ns profiles
    - packaging: tweak handling of usr.lib.snapd.snap-confine
    - interfaces: allow introspecting network-manager on core
    - tests/main/interfaces-contacts-service: disable on openSUSE
      Tumbleweed
    - tests/lib/lxd-snapfuse: restore mount changes introduced by LXD
    - snap: fix default-provider in seed validation
    - tests: update system-usernames test now that opensuse-15.1 works
    - overlord: set fake sertial in TestRemodelSwitchToDifferentKernel
    - gadget: rename "boot{select,img}" -> system-boot-{select,image}
    - tests: listing test, make accepted snapd/core versions consistent

 -- Michael Vogt <michael.vogt@ubuntu.com>  Wed, 30 Oct 2019 13:17:43 +0100

snapd (2.42-1) unstable; urgency=medium

  * New upstream release

 -- Michael Vogt <michael.vogt@ubuntu.com>  Tue, 01 Oct 2019 11:40:58 +0200

snapd (2.41-1) unstable; urgency=medium

  [ Michael Vogt ]
  * New upstream release, LP: #1840740

  [ Jamie Strandboge ]
  * debian/control: Depends on apparmor >= 2.10.95-5 instead of
    2.10.95-0ubuntu2.2 since 2.10.95-5 in Debian is the first version to have
    all the patches that 2.10.95-0ubuntu2.2 in Ubuntu brought.

 -- Michael Vogt <michael.vogt@ubuntu.com>  Fri, 30 Aug 2019 08:53:57 +0200

snapd (2.40-1) unstable; urgency=medium

  * New upstream release.

 -- Michael Vogt <mvo@debian.org>  Tue, 23 Jul 2019 15:38:36 +0200

snapd (2.39.3-1) unstable; urgency=medium

  * New upstream release, LP: #1827495
    - daemon: increase `shutdownTimeout` to 25s to deal with slow HW
    - spread: run tests against openSUSE 15.1
    - data/selinux: fix policy for snaps with bases and classic snaps

 -- Michael Vogt <michael.vogt@ubuntu.com>  Fri, 21 Jun 2019 09:06:01 +0200

snapd (2.39.2-1) unstable; urgency=medium

  * New upstream release, LP: #1827495
    - debian: rework how we run autopkgtests
    - interfaces/docker-support: add overlayfs accesses for ubuntu core
    - data/selinux: permit init_t to remount snappy_snap_t
    - strutil/shlex: fix ineffassign
    - packaging: fix build-depends on powerpc

 -- Michael Vogt <michael.vogt@ubuntu.com>  Wed, 05 Jun 2019 08:46:14 +0200

snapd (2.39-1) unstable; urgency=medium

   * New upstream release
   * d/patches0008-snap-squashsh-skip-TestBuildDate-on-Debian.patch: drop,
     fixed upstream

 -- Zygmunt Krynicki <me@zygoon.pl>  Thu, 28 Feb 2019 18:21:26 +0100

snapd (2.39.1-1) unstable; urgency=medium

  * New upstream release

 -- Michael Vogt <michael.vogt@ubuntu.com>  Wed, 29 May 2019 12:08:43 +0200

snapd (2.38-1) unstable; urgency=medium

  * New upstream release

 -- Michael Vogt <michael.vogt@ubuntu.com>  Thu, 21 Mar 2019 11:02:04 +0100

=== debian/rules ===
--- 
+++ 
@@ -17,8 +17,6 @@
 export DH_GOLANG_GO_GENERATE=1
 
 export PATH:=${PATH}:${CURDIR}
-# make sure that correct go version is found on trusty
-export PATH:=/usr/lib/go-1.6/bin:${PATH}
 
 include /etc/os-release
 
@@ -91,12 +89,8 @@
 endif
     BUILT_USING_PACKAGES=libcap-dev libapparmor-dev libseccomp-dev
 else
-ifeq ($(shell dpkg-vendor --query Vendor),Debian)
     VENDOR_ARGS=--enable-nvidia-multiarch
     BUILT_USING_PACKAGES=libcap-dev
-else
-    VENDOR_ARGS=--disable-apparmor
-endif
 endif
 BUILT_USING=$(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W $(BUILT_USING_PACKAGES))
 
@@ -145,15 +139,17 @@
 
 	# (static linking on powerpc with cgo is broken)
 ifneq ($(shell dpkg-architecture -qDEB_HOST_ARCH),powerpc)
-	# Generate static snap-exec and snap-update-ns - it somehow includes CGO so
+	# Generate static snap-exec, snapctl and snap-update-ns - it somehow includes CGO so
 	# we must force a static build here. We need a static snap-{exec,update-ns}
 	# inside the core snap because not all bases will have a libc
-	(cd _build/bin && GOPATH=$$(pwd)/.. CGO_ENABLED=0 go build $(GCCGOFLAGS) $(DH_GOPKG)/cmd/snap-exec)
-	(cd _build/bin && GOPATH=$$(pwd)/.. go build --ldflags '-extldflags "-static"' $(GCCGOFLAGS) $(DH_GOPKG)/cmd/snap-update-ns)
+	(cd _build/bin && GOPATH=$$(pwd)/.. GOCACHE=/tmp/go-build CGO_ENABLED=0 go build $(GCCGOFLAGS) -pkgdir=$$(pwd)/std $(DH_GOPKG)/cmd/snap-exec)
+	(cd _build/bin && GOPATH=$$(pwd)/.. GOCACHE=/tmp/go-build CGO_ENABLED=0 go build $(GCCGOFLAGS) -pkgdir=$$(pwd)/std $(DH_GOPKG)/cmd/snapctl)
+	(cd _build/bin && GOPATH=$$(pwd)/.. GOCACHE=/tmp/go-build go build --ldflags '-extldflags "-static"' $(GCCGOFLAGS) -pkgdir=$$(pwd)/std $(DH_GOPKG)/cmd/snap-update-ns)
 
 	# ensure we generated a static build
 	$(shell	if ldd _build/bin/snap-exec; then false "need static build"; fi)
 	$(shell	if ldd _build/bin/snap-update-ns; then false "need static build"; fi)
+	$(shell	if ldd _build/bin/snapctl; then false "need static build"; fi)
 endif
 
 	# ensure snap-seccomp is build with a static libseccomp on Ubuntu
@@ -179,11 +175,9 @@
 	$(MAKE) -C data all
 
 override_dh_auto_test:
-	dh_auto_test -- $(GCCGOFLAGS)
+	#dh_auto_test -- $(GCCGOFLAGS)
 # a tested default (production) build should have no test keys
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	# check that only the main trusted account-keys are included
 	[ $$(strings _build/bin/snapd|grep -c -E "public-key-sha3-384: [a-zA-Z0-9_-]{64}") -eq 2 ]
 	strings _build/bin/snapd|grep -c "^public-key-sha3-384: -CvQKAwRQ5h3Ffn10FILJoEZUXOv6km9FwA80-Rcj-f-6jadQ89VRswHNiEB9Lxk$$"
-	strings _build/bin/snapd|grep -c "^public-key-sha3-384: d-JcZF9nD9eBw7bwMnH61x-bklnQOhQud1Is6o_cn2wTj8EYDi9musrIT9z2MdAa$$"
-	# same for snap-repair
